// Example of spoc processor routine
// This displays periodically the string "Hello world!" on an RS-232 terminal


////
// set the stack pointer (required since we use a subroutine below)
  do #0x0C00 -> SP

Begin:
  do #GreetingString -> CS

SendChar:
  sel CS.p
  do #0x1000 -> WA0
  do.byte @ -> @  // transmit one byte out of RS-232 TX

// check the RS-232 TX busy bit
  do #0x1000 -> RA0
LoopTxD_ready:
  do.bit @
  jmp.z=1 #LoopTxD_ready

// check end of string
  do CS-#GreetingStringEnd
  jmp.z=1 #SendChar

// once string completely sent, delay before sending again
  jsr #Delay
  jmp #Begin

// delay subroutine
Delay:
  do.dw #200000 -> A
DelayLoop:
  dec.dw A
  jmp.z=1 #DelayLoop
  ret

GreetingString:
  data.byte "Hello world!", 13
GreetingStringEnd:

// that's all folks
